'World Clock
'Jan. 7, 2001
'By Achilles Mina

'This utility is one of the modules of Calculait 3.0, a full-featured
'scientific calculator with a world clock. It will soon be available
'for downloading from ZDNet, Nonags, RocketDownload, CNet and other freeware
'sites. Version 2.0 is currently downloadable at these sites.

'This version fixes the turn-of-the-month and turn-of-the-year bugs in
'time zones outside user's.

'You can do as you please with this code.

$INCLUDE "RAPIDQ.INC"

DECLARE SUB Ini
DECLARE SUB ExitSave
DECLARE SUB City
DECLARE SUB TZone
DECLARE SUB CloseTZone
DECLARE SUB HonTime
DECLARE SUB NYTime
DECLARE SUB HKTime
DECLARE SUB LATime
DECLARE SUB LonTime
DECLARE SUB ParTime
DECLARE SUB MadTime
DECLARE SUB RomTime
DECLARE SUB HelTime
DECLARE SUB BerTime
DECLARE SUB MosTime
DECLARE SUB TokTime
DECLARE SUB StoTime
DECLARE SUB ManTime
DECLARE SUB SydTime
DECLARE SUB RioTime
DECLARE SUB AucTime
DECLARE SUB GuaTime
DECLARE SUB MexTime
DECLARE SUB TorTime
DECLARE SUB MumTime
DECLARE SUB JakTime
DECLARE SUB RiyTime
DECLARE SUB HavTime
DECLARE SUB MilTime
DECLARE SUB CaiTime
DECLARE SUB SLTime
DECLARE SUB HouTime
DECLARE SUB KarTime
DECLARE SUB CarTime
DECLARE SUB TehTime
DECLARE SUB RanTime
DECLARE SUB WorldTimeDate

DEFSTR GMTDiff$, inifile, City$, DateLine$
DEFBYTE soundoff, Military
DEFSHORT HourDiff, MinDiff, GMTDiff

CREATE TimeFont AS QFONT
    Name = "Univers"
    Color = clGreen
    Size = 12
    AddStyles(fsBold)
END CREATE

CREATE ArialW14 AS QFONT
    Name = "Arial"
    Color = clWhite
    AddStyles(fsBold)
    Size = 14
END CREATE

CREATE Timer1 AS QTIMER
  Enabled = 1
  Interval = 1000
  OnTimer = WorldTimeDate
END CREATE

CREATE FORM AS QFORM
  Color = &HABC111
  Caption = "World Clock: standard time"
  Center
  Width = 258
  Height = 600
  DelBorderIcons(biMaximize)    
  FormStyle = fsStayOnTop
  ShowHint = 1
  Hint = "Remember, to get DST: World Clock time + 1 hour"
  CREATE Label1 AS QPANEL
    Color = clBlue
    Alignment = taCenter
    Caption = "The time is"
    BevelInner = 1
    BevelOuter = 2
    BevelWidth = 4
    Left = 10
    Top = 13
    Width = 230
    Height = 33
    Font = ArialW14
    OnClick = City
    Cursor = -21
    Hint = "Click to change city"
    ShowHint = 1
  END CREATE
  CREATE BlankLabel1 AS QPANEL
    Alignment = taCenter 
    Left = 10
    Top = 53
    Width = 115
    Color = clBlack
    Height = 30
    Font = TimeFont
  END CREATE
  CREATE BlankLabel2 AS QPANEL
    Alignment = taCenter
    Left = 125
    Top = 53
    Width = 115
    Height = 30
    Color = clBlack
    Font = TimeFont
  END CREATE
  CREATE TimeForm AS QPANEL
    Top = 87   
    Left = 17
    Width = 215
    Height = 485    
    Color = &HABE111
    CREATE MilButton AS QCOOLBTN
      Top = 5
      Left = 5
      Width = 100
      Height = 25
      Caption = "Military"
      Enabled = 0
	Hint = TIME$
	Showhint = 1
      OnClick = MilTime
    END CREATE
    CREATE ManButton AS QCOOLBTN
      Top = 5
      Left = 110
      Width = 100
      Height = 25
	Caption = "Manila"
      Hint = "Manila, Singapore, Kuala Lumpur, Brunei" 
	Showhint = 1
      OnClick = ManTime
    END CREATE
    CREATE HKButton AS QCOOLBTN
      Top = 35
      Left = 5
      Width = 100
      Height = 25
      Caption = "Hong Kong"
	Hint = "Hong Kong, Macau, Taipei, Beijing, Perth"
	Showhint = 1
      OnClick = HKTime
    END CREATE
    CREATE LAButton AS QCOOLBTN
      Top = 395
      Left = 110
      Width = 100
      Height = 25
      Caption = "Los Angeles"
	Hint = "Los Angeles, San Francisco, Las Vegas, U.S. Pacific Coast"
	Showhint = 1
      OnClick = LATime
    END CREATE
    CREATE LonButton AS QCOOLBTN
      Top = 65
      Left = 5
      Width = 100
      Height = 25
      Caption = "London"
	Hint = "London, Dublin, Edinburgh, Greenwich, Lisbon" 
	Showhint = 1
      OnClick = LonTime
    END CREATE
    CREATE ParButton AS QCOOLBTN
      Top = 65
      Left = 110
      Width = 100
      Height = 25
      Caption = "Paris"
	Hint = "Paris, Provence, Vienna, Normandy, Monaco"
	Showhint = 1
      OnClick = ParTime
    END CREATE
    CREATE MadButton AS QCOOLBTN
      Top = 95
      Left = 5
      Width = 100
      Height = 25
      Caption = "Madrid"
	Hint = "Madrid, Barcelona, Seville, Sofia, Luxemburg"
	Showhint = 1
      OnClick = MadTime
    END CREATE
    CREATE BerButton AS QCOOLBTN
      Top = 95
      Left = 110
      Width = 100
      Height = 25
      Caption = "Berlin"
  	Hint = "Berlin, Munich, Hamburg, Warsaw, Sarajevo, Zagreb"
	Showhint = 1
      OnClick = BerTime
    END CREATE
    CREATE HelButton AS QCOOLBTN
      Top = 125
      Left = 5
      Width = 100
      Height = 25
      Caption = "Helsinki"
	Hint = "Helsinki, Riga, Talinn, Minsk"
	Showhint = 1
      OnClick = HelTime
    END CREATE
    CREATE MosButton AS QCOOLBTN
      Top = 125
      Left = 110
      Width = 100
      Height = 25
      Caption = "Moscow"
      Hint = "Moscow, St. Petersburg, Volgograd"
	Showhint = 1
      OnClick = MosTime
    END CREATE
    CREATE RomButton AS QCOOLBTN
      Top = 155
      Left = 5
      Width = 100
      Height = 25
	Caption = "Rome"
      Hint = "Rome, Milan, Venice, Amsterdam, Bern, Prague"
	Showhint = 1
      OnClick = RomTime
    END CREATE
    CREATE TokButton AS QCOOLBTN
      Top = 245
      Left = 110
      Width = 100
      Height = 25
	Caption = "Tokyo"
      Hint = "Tokyo, Osaka, Sapporo, Okinawa, Seoul, Yakutsk"
	Showhint = 1
      OnClick = TokTime
    END CREATE
    CREATE HonButton AS QCOOLBTN
      Top = 185
      Left = 5
      Width = 100
      Height = 25
	Caption = "Honolulu"
      Hint = "Honolulu, Tahiti, French Polynesia, Fairbanks, Anchorage"
	Showhint = 1
      OnClick = HonTime
    END CREATE
    CREATE StoButton AS QCOOLBTN
      Top = 155
      Left = 110
      Width = 100
      Height = 25
      Caption = "Stockholm"
      Hint = "Stockholm, Copenhagen, Oslo, Vilnius"
	Showhint = 1
      OnClick = StoTime
    END CREATE
    CREATE SydButton AS QCOOLBTN
      Top = 215
      Left = 5
      Width = 100
      Height = 25
      Caption = "Sydney"
	Hint = "Sydney, Canberra, Melbourne, Brisbane, Hobart, Vladivostok"
	Showhint = 1
      OnClick = SydTime
    END CREATE
    CREATE RioButton AS QCOOLBTN
      Top = 275
      Left = 110
      Width = 100
      Height = 25
	Caption = "Rio de Janeiro"
      Hint = "Rio de Janeiro, Buenos Aires, Sao Paolo, Uruguay, Greenland"
	Showhint = 1
      OnClick = RioTime
    END CREATE
    CREATE AucButton AS QCOOLBTN
      Top = 245
      Left = 5
      Width = 100
      Height = 25
      Caption = "Auckland"
      Hint = "Auckland, Wellington, Suva, Marshall Islands"
	Showhint = 1
      OnClick = AucTime
    END CREATE
    CREATE GuaButton AS QCOOLBTN
      Top = 185
      Left = 110
      Width = 100
      Height = 25
      Caption = "Guam"
      Hint = "Guam, Saipan, Port Moresby, Marianas"
	Showhint = 1
      OnClick = GuaTime
    END CREATE
    CREATE MexButton AS QCOOLBTN
      Top = 275
      Left = 5
      Width = 100
      Height = 25
      Caption = "Mexico"
      Hint = "Mexico, Honduras, Guatemala, Nicaragua, Costa Rica"
	Showhint = 1
      OnClick = MexTime
    END CREATE
    CREATE TorButton AS QCOOLBTN
      Top = 215
      Left = 110
      Width = 100
      Height = 25
      Caption = "Toronto"
	Hint = "Toronto, Quebec, Ottawa, Montreal"
	Showhint = 1
      OnClick = TorTime
    END CREATE
    CREATE MumButton AS QCOOLBTN
      Top = 305
      Left = 5
      Width = 100
      Height = 25
	Caption = "Mumbai"
      Hint = "Mumbai, Calcutta, Madras, New Delhi"
	Showhint = 1
      OnClick = MumTime
    END CREATE
    CREATE KarButton AS QCOOLBTN
      Top = 305
      Left = 110
      Width = 100
      Height = 25
	Caption = "Karachi"
      Hint = "Karachi, Islamabad, Tashkent"
	Showhint = 1
      OnClick = KarTime
    END CREATE
    CREATE CarButton AS QCOOLBTN
      Top = 335
      Left = 5
      Width = 100
      Height = 25
	Caption = "Caracas"
      Hint = "Caracas, Santiago, La Paz, Bermuda, Virgin Is."
	Showhint = 1
      OnClick = CarTime
    END CREATE
    CREATE DelButton AS QCOOLBTN
      Top = 35
      Left = 110
      Width = 100
      Height = 25
      Caption = "Jakarta"
	Hint = "Jakarta, Hanoi, Saigon, Bangkok, Sumatra"
	Showhint = 1
      OnClick = JakTime
    END CREATE
    CREATE RiyButton AS QCOOLBTN
      Top = 365
      Left = 5
      Width = 100
      Height = 25
      Caption = "Riyadh"
	Hint = "Riyadh, Kuwait, Bahrain, Nairobi, Addis Ababa"
	Showhint = 1
      OnClick = RiyTime
    END CREATE
    CREATE HavButton AS QCOOLBTN
      Top = 335
      Left = 110
      Width = 100
      Height = 25
      Caption = "Havana"
	Hint = "Havana, Jamaica, Bahamas, Haiti, Ecuador"
	Showhint = 1
      OnClick = HavTime
    END CREATE
    CREATE NYButton AS QCOOLBTN
      Top = 395
      Left = 5
      Width = 100
      Height = 25
	Caption = "New York"
      Hint = "New York, Washington D.C., Boston, Atlanta, Miami, U.S. Atlantic Coast"
	Showhint = 1
      OnClick = NYTime
    END CREATE
    CREATE CaiButton AS QCOOLBTN
      Top = 365
      Left = 110
      Width = 100
      Height = 25
      Caption = "Cairo"
      Hint = "Cairo, Jerusalem, Baghdad, Istanbul, Athens, Bucharest"
	Showhint = 1
      OnClick = CaiTime
    END CREATE
    CREATE SLButton AS QCOOLBTN
      Top = 425
      Left = 5
      Width = 100
      Height = 25
	Caption = "Salt Lake"
      Hint = "Salt Lake, Phoenix, Denver, U.S. Mountain Zone"
	Showhint = 1
      OnClick = SLTime
    END CREATE
    CREATE HouButton AS QCOOLBTN
      Top = 425
      Left = 110
      Width = 100
      Height = 25
      Caption = "Houston"
      Hint = "Houston, Dallas, Chicago, New Orleans, Memphis, U.S. Central Zone"
	Showhint = 1
      OnClick = HouTime
    END CREATE
    CREATE TehButton AS QCOOLBTN
      Top = 455
      Left = 5
      Width = 100
      Height = 25
	Caption = "Tehran"
      Hint = "Tehran"
	Showhint = 1
      OnClick = TehTime
    END CREATE
    CREATE RanButton AS QCOOLBTN
      Top = 455
      Left = 110
      Width = 100
      Height = 25
      Caption = "Rangoon"
      Hint = "Rangoon"
	Showhint = 1
      OnClick = RanTime
    END CREATE
  END CREATE
END CREATE

SUB WorldTimeDate
  DEFBYTE Interval, yesterday, tomorrow, day, endday, month
  DEFINT hour, hour0, min, min0, year
  IF military = 1 THEN
    BlankLabel1.Caption = TIME$
  ELSE 
    hour0 =  VAL(LEFT$(time$,2))
    min0 = VAL(MID$(time$,4,2)) 
    IF City$ = DateLine$ THEN
      MinDiff = 0
    ELSEIF City$ <> "" AND DateLine$ = "" THEN
      MinDiff = 0  
    ELSE
      SELECT CASE City$
        CASE "Mum","Ran","Teh"
          MinDiff = -30  
      END SELECT
    END IF    
    min = min0 + MinDiff
    IF min >= 60 THEN
      min = min - 60
      hour0 = VAL(LEFT$(time$,2)) + 1
    ELSEIF min < 0 THEN
      min = min + 60
      hour0 = VAL(LEFT$(time$,2)) - 1
    END IF
    hour = hour0 + HourDiff
    IF hour < 0 THEN
      hour = hour + 24
      ampm$ = " AM"
      IF hour > 12 THEN 
        hour = hour - 12
        ampm$ = " PM"
      END IF
      yesterday = 1
    ELSEIF hour >= 24 THEN
      hour = hour - 24
      IF hour = 0 THEN hour = 12
      ampm$ = " AM"
      tomorrow = 1
    ELSEIF hour >= 12 AND hour < 24 THEN
      hour = hour - 12
      IF hour = 0 THEN hour = 12
      ampm$ = " PM"
    ELSEIF hour = 0 THEN 
      hour = 12
      ampm$ = " AM"
    ELSE
      ampm$ = " AM"
    END IF
    IF min < 10 THEN
      BlankLabel1.Caption = STR$(hour) + ":0" + STR$(min) + RIGHT$(time$,3) + ampm$
    ELSE
      BlankLabel1.Caption = STR$(hour) + ":" + STR$(min) + RIGHT$(time$,3) + ampm$
    END IF
    day = VAL(MID$(date$,4,2))
    month$ = LEFT$(date$,2)
    month = VAL(month$)
    year$ = RIGHT$(date$,4)
    year = VAL(year$)
    IF yesterday = 1 THEN
      IF day = 1 THEN
        SELECT CASE month
          CASE 5, 7, 10, 12
            day = 30
          CASE 3
            IF year MOD 4 = 0 THEN
              day = 29
              IF year MOD 100 = 0 THEN
                IF year MOD 400 <> 0 THEN day = 28
              END IF
            ELSE
              day = 28
            END IF
          CASE ELSE
            day = 31
        END SELECT
        DEC month
        IF month = 0 THEN month = 12        
      ELSE
        DEC day 
      END IF
      yesterday = 0
    ELSEIF tomorrow = 1 THEN
      endday = 0
      SELECT CASE month
        CASE 1, 3, 5, 7, 8, 10, 12
          endday = 31
        CASE 2
          IF year MOD 4 = 0 THEN
            endday = 29
            IF year MOD 100 = 0 THEN
              IF year MOD 400 = 0 THEN endday = 29
            END IF
          ELSE
            endday = 28
          END IF
        CASE ELSE
          endday = 30
      END SELECT
      IF day = endday THEN 
        day = 1
        INC month
        IF month = 13 THEN
          month = 1
          INC year
        END IF
      ELSE
        INC day
      END IF  
      tomorrow = 0
    END IF
    month$ = STR$(month)
    day$ = STR$(day)
    year$ = STR$(year)     
    BlankLabel2.Caption =  month$ + "-" + day$ + "-" + year$
  ELSE 
    BlankLabel2.Caption = date$
  END IF
END SUB

SUB City
  IF soundoff = 0 THEN PLAYWAV  "gong.wav",1
  TimeForm.Color = clRed
  Label1.Caption = "Click city you're in." 
  MilButton.Enabled = 0
END SUB

SUB TZone
  IF soundoff = 0 THEN PLAYWAV  "gong.wav",1
  IF GMTDiff$ = "" THEN
    TimeForm.Color = clRed
    Label1.Caption = "Click city you're in."
    MilButton.Enabled = 0
  ELSE
    Label1.Caption = "Click a city."
    MilButton.Enabled = 1  
  END IF
END SUB

SUB ManTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    MilButton.Enabled = 1
    TimeForm.Color = &HABC111
    GMTDiff = -8
    GMTDiff$ = "-8"
    City$ = "Man"
  END IF
  DateLine$ = "Man" 
  MinDiff = 0
  HourDiff = GMTDiff + 8
  Military = 0
  WorldTimeDate
  Label1.Caption = "Manila time/date:"
END SUB

SUB NYTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 5
    GMTDiff$ = "5"
    City$ = "NY"
  END IF
  DateLine$ = "NY" 
  MinDiff = 0
  HourDiff = GMTDiff - 5
  Military = 0
  WorldTimeDate
  Label1.Caption = "New York time/date:"
END SUB

SUB LATime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 8
    GMTDiff$ = "8"
    City$ = "LA"
  END IF
  DateLine$ = "LA" 
  MinDiff = 0
  HourDiff = GMTDiff - 8
  Military = 0
  WorldTimeDate
  Label1.Caption = "Los Angeles time/date:"
END SUB

SUB SLTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 7
    GMTDiff$ = "7"
    City$ = "SL"
  END IF
  DateLine$ = "SL" 
  MinDiff = 0
  HourDiff = GMTDiff - 7
  Military = 0
  WorldTimeDate
  Label1.Caption = "Salt Lake time/date:"
END SUB

SUB HouTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 6
    GMTDiff$ = "6"
    City$ = "Hou"
  END IF
  DateLine$ = "Hou"
  MinDiff = 0
  HourDiff = GMTDiff - 6
  Military = 0
  WorldTimeDate
  Label1.Caption = "Houston time/date:"
END SUB

SUB TehTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -3
    GMTDiff$ = "-3"
    City$ = "Teh"
  END IF
  DateLine$ = "Teh"
  MinDiff = 30
  HourDiff = GMTDiff + 3
  Military = 0
  WorldTimeDate
  Label1.Caption = "Tehran time/date:"
END SUB

SUB RanTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -6
    GMTDiff$ = "-6"
    City$ = "Ran"
  END IF
  DateLine$ = "Ran"
  MinDiff = 30
  HourDiff = GMTDiff + 6
  Military = 0
  WorldTimeDate
  Label1.Caption = "Rangoon time/date:"
END SUB

SUB HKTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -8
    GMTDiff$ = "-8"
    Label1.Caption = "Dateline: Hong Kong"
    City$ = "HK"
  END IF
  DateLine$ = "HK"
  MinDiff = 0
  HourDiff = GMTDiff + 8
  Military = 0
  WorldTimeDate
  Label1.Caption = "Hong Kong time/date:"
END SUB

SUB LonTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 0
    GMTDiff$ = ""
    City$ = "Lon"
  END IF
  DateLine$ = "Lon"
  MinDiff = 0
  HourDiff = GMTDiff
  Military = 0
  WorldTimeDate
  Label1.Caption = "London time/date:"
END SUB

SUB MadTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -1
    GMTDiff$ = "-1"
    City$ = "Mad"
  END IF
  DateLine$ = "Mad"
  MinDiff = 0
  HourDiff = GMTDiff + 1
  Military = 0
  WorldTimeDate
  Label1.Caption = "Madrid time/date:"
END SUB

SUB ParTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -1
    GMTDiff$ = "-1"
    City$ = "Par"
  END IF
  DateLine$ = "Par"
  MinDiff = 0
  HourDiff = GMTDiff + 1
  Military = 0
  WorldTimeDate
  Label1.Caption = "Paris time/date:"
END SUB

SUB BerTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -1
    GMTDiff$ = "-1"
    City$ = "Ber"
  END IF
  DateLine$ = "Ber"
  MinDiff = 0
  HourDiff = GMTDiff + 1
  Military = 0
  WorldTimeDate
  Label1.Caption = "Berlin time/date:"
END SUB

SUB RomTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -1
    GMTDiff$ = "-1"
    City$ = "Rom"
  END IF
  DateLine$ = "Rom"
  MinDiff = 0
  HourDiff = GMTDiff + 1
  Military = 0
  WorldTimeDate
  Label1.Caption = "Rome time/date:"
END SUB

SUB HelTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -2
    GMTDiff$ = "-2"
    City$ = "Hel"
  END IF
  DateLine$ = "Hel"
  MinDiff = 0
  HourDiff = GMTDiff + 2
  Military = 0
  WorldTimeDate
  Label1.Caption = "Helsinki time/date:"
END SUB

SUB MosTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -3
    GMTDiff$ = "-3"
    City$ = "Mos"
  END IF
  DateLine$ = "Mos"
  MinDiff = 0
  HourDiff = GMTDiff + 3
  Military = 0
  WorldTimeDate
  Label1.Caption = "Moscow time/date:"
END SUB

SUB TokTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -9
    GMTDiff$ = "-9"
    City$ = "Tok"
  END IF
  DateLine$ = "Tok"
  MinDiff = 0
  HourDiff = GMTDiff + 9
  Military = 0
  WorldTimeDate
  Label1.Caption = "Tokyo time/date:"
END SUB

SUB HonTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 10
    GMTDiff$ = "10"
    City$ = "Hon"
  END IF
  DateLine$ = "Hon"
  MinDiff = 0
  HourDiff = GMTDiff - 10
  Military = 0
  WorldTimeDate
  Label1.Caption = "Honolulu time/date:"
END SUB

SUB StoTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -1
    GMTDiff$ = "-1"
    City$ = "Sto"
  END IF
  DateLine$ = "Sto"
  MinDiff = 0
  HourDiff = GMTDiff + 1
  Military = 0
  WorldTimeDate
  Label1.Caption = "Stockholm time/date:"
END SUB

SUB SydTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -10
    GMTDiff$ = "-10"
    City$ = "Syd"
  END IF
  DateLine$ = "Syd"
  MinDiff = 0
  HourDiff = GMTDiff + 10
  Military = 0
  WorldTimeDate
  Label1.Caption = "Sydney time/date:"
END SUB

SUB RioTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 3
    GMTDiff$ = "3"
    City$ = "Rio"
  END IF
  DateLine$ = "Rio"
  MinDiff = 0
  HourDiff = GMTDiff - 3
  Military = 0
  WorldTimeDate
  Label1.Caption = "R. de Janeiro time/date:"
END SUB

SUB AucTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -12
    GMTDiff$ = "-12"
    City$ = "Auc"
  END IF
  DateLine$ = "Auc"
  MinDiff = 0
  HourDiff = GMTDiff + 12
  Military = 0
  WorldTimeDate
  Label1.Caption = "Auckland time/date:"
END SUB

SUB GuaTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -10
    GMTDiff$ = "-10"
    City$ = "Gua"
  END IF
  DateLine$ = "Gua"
  MinDiff = 0
  HourDiff = GMTDiff + 10
  Military = 0
  WorldTimeDate
  Label1.Caption = "Guam time/date:"
END SUB

SUB MexTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 6
    GMTDiff$ = "6"
    City$ = "Mex"
  END IF
  DateLine$ = "Mex"
  MinDiff = 0
  HourDiff = GMTDiff - 6
  Military = 0
  WorldTimeDate
  Label1.Caption = "Mexico time/date:"
END SUB

SUB TorTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 5
    GMTDiff$ = "5"
    City$ = "Tor"
  END IF
  DateLine$ = "Tor"
  MinDiff = 0
  HourDiff = GMTDiff - 5
  Military = 0
  WorldTimeDate
  Label1.Caption = "Toronto time/date:"
END SUB

SUB MumTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -5
    GMTDiff$ = "-5"
    City$ = "Mum"    
  END IF
  DateLine$ = "Mum"    
  MinDiff = 30
  HourDiff = GMTDiff + 5
  Military = 0
  WorldTimeDate
  Label1.Caption = "Mumbai time/date:"
END SUB

SUB JakTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -7
    GMTDiff$ = "-7"
    City$ = "Jak"
  END IF
  DateLine$ = "Jak"
  MinDiff = 0
  HourDiff = GMTDiff + 7
  Military = 0
  WorldTimeDate
  Label1.Caption = "Jakarta time/date:"
END SUB

SUB RiyTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -3
    GMTDiff$ = "-3"
    City$ = "Riy"
  END IF
  DateLine$ = "Riy"
  MinDiff = 0
  HourDiff = GMTDiff + 3
  Military = 0
  WorldTimeDate
  Label1.Caption = "Riyadh time/date:"
END SUB

SUB HavTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 5
    GMTDiff$ = "5"
    City$ = "Hav"
  END IF
  DateLine$ = "Hav"
  MinDiff = 0
  HourDiff = GMTDiff - 5
  Military = 0
  WorldTimeDate
  Label1.Caption = "Havana time/date:"
END SUB

SUB CaiTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -2
    GMTDiff$ = "-2"
    City$ = "Cai"
  END IF
  DateLine$ = "Cai"
  MinDiff = 0
  HourDiff = GMTDiff + 2
  Military = 0
  WorldTimeDate
  Label1.Caption = "Cairo time/date:"
END SUB

SUB CarTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = 4
    GMTDiff$ = "4"
    City$ = "Car"
  END IF
  DateLine$ = "Car"
  MinDiff = 0
  HourDiff = GMTDiff - 4
  Military = 0
  WorldTimeDate
  Label1.Caption = "Caracas time/date:"
END SUB

SUB KarTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  IF TimeForm.Color = clRed THEN
    TimeForm.Color = &HABC111
    GMTDiff = -5
    GMTDiff$ = "-5"
    City$ = "Kar"
  END IF
  DateLine$ = "Kar"
  MinDiff = 0    
  HourDiff = GMTDiff + 5
  Military = 0
  WorldTimeDate
  Label1.Caption = "Karachi time/date:"
END SUB

SUB MilTime
  IF soundoff = 0 THEN PLAYWAV  "cuckoo.wav",1
  Military = 1
  WorldTimeDate
END SUB

SUB Ini
  Application.HintPause = 250
  Application.HintHidePause = 10000    
  IF FILEEXISTS("wclock.ini") <> 0 THEN
    DIM File as QFileStream
    File.Open("wclock.ini",fmOpenReadWrite)
    inifile = File.ReadStr(File.Size)
    City$ = LEFT$(inifile,3)  
    GMTDiff$ = MID$(inifile,4,3)       
    GMTDiff = VAL(GMTDiff$)
    File.Close 
  ELSE
    City$ = "" 
    GMTDiff$ = ""     
    GMTDiff = 0
  END IF
  TZone
END SUB

SUB ExitSave
  DIM File AS QFileStream
  GMTDiff$ = STR$(GMTDiff)
  IF LEN(GMTDiff$) = 1 THEN
    GMTDiff$ = "  " + GMTDiff$
  ELSEIF LEN(GMTDiff$) = 2 THEN
    GMTDiff$ = " " + GMTDiff$
  END IF
  File.Open("wclock.ini",fmCreate)
  inifile = City$ + GMTDiff$
  File.WriteStr(inifile,LEN(inifile))
  File.Close
  Application.Terminate
END SUB

Ini
Form.ShowModal
ExitSave